/*****************************************************************************
 *****************************************************************************
 Copyright (c) 2000-2001, AEP Ltd. 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.

 3. Neither the name of AEP Ltd. nor the names of its contributors 
 may be used to endorse or promote products derived from this software 
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
****************************************************************************/

/**********************************************************************
*                                                                     *
* AEP Ltd.                                                            *
*                                                                     *
* This software is supplied under the terms of the license included   *
* above.  All use of this software must be in accordance with the     *
* terms of that license.                                              *
*                                                                     *
**********************************************************************/

#include <semaphore.h>
#include <sys/time.h>
#include "aep_i_types.h"
#include "aep_i_defs.h"

/*********************Various defines*********************/
#define BOOL int

/*Because of an optimisation used in the hash function, the hash table size must
be a multiple of 2.*/
#define MAX_AEP_RESPONSE_TABLE_SIZE (1 << 16)
/* Now AEP_HASH_MASK is a variable */
/*#define AEP_HASH_MASK (MAX_AEP_RESPONSE_TABLE_SIZE - 1) */
#define MAX_ASIC_BUFFER_SIZE		66560
#define MAX_DES_BUFFER_SIZE			66560
#define MAX_SA_BUFFER_SIZE			66560
#define MAX_ASIC_WRITE_TIMEOUT		100000000
#define MAX_DES_WRITE_TIMEOUT		100000000
#define MAX_SA_WRITE_TIMEOUT		100000000
#define MAX_READ_BUFFER_SIZE		66560


#define BUFFER_SIZE			66560
/*#define WRITE_TIMEOUT		100000000*/
#define NUM_CONTEXTS_REQUESTED	300
#define CONTEXTS_LOW_MARK	100



#define KEY_DB_PORT	3000

typedef struct AEP_I_RESPONSE_DATA {
  AEP_TRANSACTION_HNDL transaction_handle;    /* the handle of this session */
  AEP_U64_PTR msg;
  sem_t *response_semaphore;
  struct timeval timestamp;
  int sock_fd;
} AEP_I_RESPONSE_DATA;

