/*****************************************************************************
 *****************************************************************************
 Copyright (c) 2000-2001, AEP Ltd. 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.

 3. Neither the name of AEP Ltd. nor the names of its contributors 
 may be used to endorse or promote products derived from this software 
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
****************************************************************************/

/**********************************************************************
*                                                                     *
* AEP Ltd.                                                            *
*                                                                     *
* This software is supplied under the terms of the license included   *
* above.  All use of this software must be in accordance with the     *
* terms of that license.                                              *
*                                                                     *
**********************************************************************/

#ifndef AEPTRACE_H
#define AEPTRACE_H

#include "aeptrace_config.h"
#include <stdarg.h>
/*--------------------------------------------------------------------------*/
/*  Logging Options															*/
/*--------------------------------------------------------------------------*/

/* Max Number of Tabs allowed */
#define MAX_NUM_TABS				32

/* Max Trace Length */
#define MAX_TRACE_LENGTH			512

/*--------------------------------------------------------------------------*/
/*  Format Options - allow indentation in log file							*/
/*--------------------------------------------------------------------------*/
#define FN_IN						2
#define FN_OUT						3
#define FN_NONE						4

#define AEP_R_FILE_OPEN_ERROR		0x11111111
#define AEP_R_EOF					0x11111111
#define AEP_R_TOO_MANY_LOG_FILES	0x11111112

#define DAEMON						0x10000001
#define API							0x10000002
#define DRIVER						0x10000003

#define DAEMON_LOG_FILE			"daemon.log"
#define API_LOG_FILE			"api.log"
#define DRIVER_LOG_FILE			"driver.log"



/* Prototype */
AEP_U32 setConfigItem(AEP_U32, AEP_U32, AEP_CHAR*, AEP_U32);
void AEP_TRACE (AEP_U32,AEP_U32,AEP_U32,AEP_CHAR_PTR,AEP_U32,
				AEP_CHAR_PTR, ...);
void logMessage(AEP_U32			Subsystem,
				AEP_U32			TraceLevel,
				AEP_U32			Indentation,
				AEP_CHAR_PTR	FunctionName,
				AEP_U32			rv,
				AEP_CHAR_PTR	Message,
				va_list 		params
				);					
int initTraceConfigItems()	;
void init(void);
void unlockMutex();
#endif
