/*****************************************************************************
 *****************************************************************************
 Copyright (c) 2000-2001, AEP Ltd. 

 All rights reserved.

 Redistribution and use in source and binary forms, with or without 
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, 
 this list of conditions and the following disclaimer.

 2. Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation 
 and/or other materials provided with the distribution.

 3. Neither the name of AEP Ltd. nor the names of its contributors 
 may be used to endorse or promote products derived from this software 
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING 
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 

 *****************************************************************************
****************************************************************************/

/**********************************************************************
*                                                                     *
* AEP Ltd.                                                            *
*                                                                     *
* This software is supplied under the terms of the license included   *
* above.  All use of this software must be in accordance with the     *
* terms of that license.                                              *
*                                                                     *
**********************************************************************/


#ifndef config_def_H 
#define config_def_H 1

#define MAX_STRING_SIZE	32

typedef struct DAEMON_CONFIG_ITEM{
	AEP_U32		dataType; /*The item identifier*/
	AEP_U32	 	dynamic;
	AEP_U32		dataSize;
	AEP_U32		value;
	AEP_U64		longValue;
	AEP_CHAR	stringValue[MAX_STRING_SIZE];
}DAEMON_CONFIG_ITEM;




/*******************************************************/
/*dataType                                             */
/*******************************************************/

#define	FIRST_CONFIG_ITEM 		 0

#define	RESPONSE_TABLE_SIZE		 0
#define ASIC_BUFFER_SIZE		 1
#define DES_BUFFER_SIZE			 2
#define SA_BUFFER_SIZE			 3
#define ASIC_WRITE_TIMEOUT		 4
#define DES_WRITE_TIMEOUT		 5
#define SA_WRITE_TIMEOUT		 6
#define READ_BUFFER_SIZE		 7
#define REQUEST_TIMEOUT			 8
#define DEVICE_NAME				 9

#define	LAST_CONFIG_ITEM 		 9
#define	CONFIG_ITEM_NUM 		(LAST_CONFIG_ITEM + 1)

/*
#define SOCKET_NAME				not used
#define KEY_DB_PORT				not used
#define NUM_CTX_REQUESTED		not used
#define CTX_LOW_WATERMARK		not used	
*/



/*******************************************************/
/* dataSize											   */
/*******************************************************/

#define U32_SIZE	0
#define U64_SIZE	1
#define STRING_SIZE	2


/*******************************************************/

#define STATIC		0
#define DYNAMIC		1

/*******************************************************/

#define CONFIG_FILE_NAME			"/etc/aep.conf"


/*Max length in characters of a line and a word respectively in the
 *daemon config file*/
#define LINE_LENGTH				200
#define WORD_LENGTH				100


/*Possible error codes. Note: may need to change these to fit in with the rest of 
 *the AEP error codes*/
#define ITEM_NOT_FOUND_ERROR		0x00000001
#define FILE_NOT_FOUND_ERROR		0x00000002
#define CONFIG_FILE_FORMAT_ERROR	0x00000003
#define FIELD_NOT_FOUND_ERROR		0x00000004
#define ERROR_READING_FILE			0x00000005
#define NOT_VALID_DATA  			0x00000006

#endif






